<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Event Capturing vs Event Bubbling</title>
    <style>
        * {
            margin: 0;
            padding: 0;
            font-family: Calibri;
        }

        html,
        body {
            width: 100%;
            height: 100%;
        }

        #level1 {
            width: 60%;
            height: 60%;
            display: flex;
            justify-content: center;
            align-items: center;
            background: lightblue;
        }

        #level2 {
            width: 60%;
            height: 60%;
            display: flex;
            justify-content: center;
            align-items: center;
            background: lightgreen;
        }

        #level3 {
            width: 60%;
            height: 60%;
            display: flex;
            justify-content: center;
            align-items: center;
            background: lightpink;
        }
    </style>
</head>

<body>
    <div id="level1">
        <div>Level 1</div>
        <div id="level2">
            <div>Level 2</div>
            <div id="level3">
                <div>Level 3</div>
                <button>Click me!</button>
            </div>
        </div>
    </div>
    <script>
        let level1Div = document.querySelector('#level1');
        let level2Div = document.querySelector('#level2');
        let level3Div = document.querySelector('#level3');

        function handleClickEvent(event, capturerId) {
            console.log(event, capturerId);
        }

        // Registering event handlers in bubbling phase
        // level1Div.addEventListener('click', (event) => handleClickEvent(event, 'level1'));
        // level2Div.addEventListener('click', (event) => handleClickEvent(event, 'level2'));
        // level3Div.addEventListener('click', (event) => handleClickEvent(event, 'level3'));

        // Registering event handlers in capturing phase
        level1Div.addEventListener('click', (event) => handleClickEvent(event, 'level1'), true);
        level2Div.addEventListener('click', (event) => handleClickEvent(event, 'level2'), true);
        level3Div.addEventListener('click', (event) => handleClickEvent(event, 'level3'), true);

    </script>
</body>

</html>